
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#include "StdAfx.h"
#include "FormatCorrector.h"

using namespace AutomateIT::CalcItems;

CFormatCorrector::CFormatCorrector( const std::wstring& formatString ) : 
    format_(formatString)
{
    
    std::vector<std::pair<std::wstring, std::wstring> > asoc;
    asoc.push_back(std::make_pair(L"am/pm", L"AM/PM"));
    asoc.push_back(std::make_pair(L"aaa",   L"AAA"));
    asoc.push_back(std::make_pair(L"ccc",   L"CCC"));
    asoc.push_back(std::make_pair(L"d",     L"D"));
    asoc.push_back(std::make_pair(L"e",     L"E"));
    asoc.push_back(std::make_pair(L"g",     L"G"));
    asoc.push_back(std::make_pair(L"h",     L"H"));
    asoc.push_back(std::make_pair(L"m",     L"M"));
    asoc.push_back(std::make_pair(L"n",     L"N"));
    asoc.push_back(std::make_pair(L"q",     L"Q"));
    asoc.push_back(std::make_pair(L"r",     L"R"));
    asoc.push_back(std::make_pair(L"s",     L"S"));
    asoc.push_back(std::make_pair(L"ww",    L"WW"));
    asoc.push_back(std::make_pair(L"yy",    L"YY"));
    
    // replace add includes
    for(size_t i = 0; i < asoc.size(); ++i)
    {
        if (asoc[i].first.size() <= format_.size())
        {
            std::wstring::iterator iter = std::search(format_.begin(), format_.end(), asoc[i].first.begin(), asoc[i].first.end());
            while(format_.end() != iter)
            {
                std::copy(asoc[i].second.begin(), asoc[i].second.end(), iter);
                if (asoc[i].first.size() > static_cast<size_t>(format_.end() - iter))
                {
                    break;
                }
                iter = std::search(iter, format_.end(), asoc[i].first.begin(), asoc[i].first.end());
            }
        }

    }

}

CFormatCorrector::~CFormatCorrector(void)
{
}

std::wstring CFormatCorrector::ToString() const
{
    return format_;
}