/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/
#ifndef _BORDER_H_
#define _BORDER_H_

#pragma once

#include "ExcelClone.h"
#include "DispatchHook.h"
#include "OOBorderLine.h"

/*
CBorder class provides functionality of the MS Excel Application object by using Open Office.
It implements Border interface of the MS Excel.
*/

namespace AutomateIT
{
    namespace ExcelClone
    {
        class ATL_NO_VTABLE CBorder : 
            public CComObjectRootEx<CComSingleThreadModel>,
            public CDispatchHook< IDispatchImpl<Border, &IID_Border, &LIBID_ExcelCloneLib, 1, 0> >
        {
        public:
            CBorder();
            virtual ~CBorder();

            BEGIN_COM_MAP(CBorder)
                COM_INTERFACE_ENTRY(Border)
                COM_INTERFACE_ENTRY(IDispatch)
            END_COM_MAP()

            DECLARE_PROTECT_FINAL_CONSTRUCT()

        public:

            HRESULT __stdcall get_Application(_Application	**RHS);

            HRESULT __stdcall get_Creator(XlCreator *RHS);

            HRESULT __stdcall get_Parent(IDispatch **RHS);

            HRESULT __stdcall get_Color(VARIANT *RHS);

            HRESULT __stdcall put_Color(VARIANT RHS);

            HRESULT __stdcall get_ColorIndex(VARIANT *RHS);

            HRESULT __stdcall put_ColorIndex(VARIANT RHS);

            HRESULT __stdcall get_LineStyle(VARIANT *RHS);

            HRESULT __stdcall put_LineStyle(VARIANT RHS);

            HRESULT __stdcall get_Weight(VARIANT *RHS);

            HRESULT __stdcall put_Weight(VARIANT RHS);

        public:

            HRESULT Initialize(CBorders* pParentBorders, OpenOfficeWrapper::COORange* pRange, OpenOfficeWrapper::COOTableBorder* pTableBorder, XlBordersIndex borderIndex);

        private:

            HRESULT SetChanges();

        private:

            OpenOfficeWrapper::COOBorderLinePtr m_pBorderLine;
            OpenOfficeWrapper::COOTableBorder* m_pParentTableBorder;
            OpenOfficeWrapper::COORange* m_pParentRange;
            XlBordersIndex m_borderIndex;
            CBorders* m_pParentBorders;

        };

        typedef CComObject<CBorder> CBorderObject;
        typedef CComPtr<CBorder> CBorderPtr;

    }
}

#endif // _BORDER_H_
