
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/
#ifndef _DISPATCH_HOOK_H_
#define _DISPATCH_HOOK_H_

namespace AutomateIT
{
	namespace ExcelClone
	{
		template <typename T>
		class CDispatchHook : public T
		{
		public:
			typedef T hookedDispInterface;

			CDispatchHook()
			{
			}

            virtual ~CDispatchHook()
			{
			}

			STDMETHOD(Invoke)(DISPID dispidMember, REFIID riid,
				LCID lcid, WORD wFlags, DISPPARAMS* pdispparams, VARIANT* pvarResult,
				EXCEPINFO* pexcepinfo, UINT* puArgErr)
			{
                WRITE_LOG_R_W((L" >> AutomateIT::ExcelClone::CDispatchHook::Invoke"));
                ThisIID();


                UINT count = 0;
                GetTypeInfoCount(&count);

                for (UINT i = 0; i < count; ++i)
                {

                    CComPtr<ITypeInfo> info(NULL); 
                    GetTypeInfo(i, lcid, &info);
                    BSTR bstrIntegfaceName(0);
                    BSTR bstrMethodName(0);
                    info->GetDocumentation(MEMBERID_NIL, &bstrIntegfaceName, NULL, NULL, NULL);
                    info->GetDocumentation(dispidMember, &bstrMethodName, NULL, NULL, NULL);
                    WRITE_LOG_R_W((L"       >>> call %s::%s", bstrIntegfaceName,  bstrMethodName));
                    SysFreeString(bstrIntegfaceName);
                    SysFreeString(bstrMethodName);
                }

				return hookedDispInterface::Invoke(dispidMember, 
					riid,lcid, wFlags, pdispparams, pvarResult, pexcepinfo, puArgErr);
			}
        private:

            void ThisIID()
            {
                LPOLESTR string;
                StringFromIID(__uuidof(this), &string);
                WRITE_LOG_R_W((L"       This = %s", string));
                CoTaskMemFree(string);
            }

		};
	}
}

#endif // _DISPATCH_HOOK_H_