
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _PAGESETUP_H_
#define _PAGESETUP_H_


#pragma once

#include "OOPageSetupStyle.h"

/*
CPageSetup class represents Excel outline object by using OpenOffice.
It implements PageSetup COM interface.
*/

namespace AutomateIT
{
    namespace ExcelClone
    {

        class ATL_NO_VTABLE CPageSetup :
            public CComObjectRootEx<CComSingleThreadModel>,
            public CDispatchHook<IDispatchImpl<PageSetup, &IID_PageSetup, &LIBID_ExcelCloneLib, 1, 0> >
        {
        public:
            CPageSetup();
            virtual ~CPageSetup();

            BEGIN_COM_MAP(CPageSetup)
                COM_INTERFACE_ENTRY(PageSetup)
                COM_INTERFACE_ENTRY(IDispatch)
            END_COM_MAP()

        public:

            HRESULT __stdcall get_Application( 
                _Application **RHS);

            HRESULT __stdcall get_Creator( 
                XlCreator *RHS);

            HRESULT __stdcall get_Parent( 
                IDispatch **RHS);

            HRESULT __stdcall get_BlackAndWhite( 
                VARIANT_BOOL *RHS);

            HRESULT __stdcall put_BlackAndWhite( 
                VARIANT_BOOL RHS);

            HRESULT __stdcall get_BottomMargin( 
                double *RHS);

            HRESULT __stdcall put_BottomMargin( 
                double RHS);

            HRESULT __stdcall get_CenterFooter( 
                BSTR *RHS);

            HRESULT __stdcall put_CenterFooter( 
                BSTR RHS);

            HRESULT __stdcall get_CenterHeader( 
                BSTR *RHS);

            HRESULT __stdcall put_CenterHeader( 
                BSTR RHS);

            HRESULT __stdcall get_CenterHorizontally( 
                VARIANT_BOOL *RHS);

            HRESULT __stdcall put_CenterHorizontally( 
                VARIANT_BOOL RHS);

            HRESULT __stdcall get_CenterVertically( 
                VARIANT_BOOL *RHS);

            HRESULT __stdcall put_CenterVertically( 
                VARIANT_BOOL RHS);

            HRESULT __stdcall get_ChartSize( 
                XlObjectSize *RHS);

            HRESULT __stdcall put_ChartSize( 
                XlObjectSize RHS);

            HRESULT __stdcall get_Draft( 
                VARIANT_BOOL *RHS);

            HRESULT __stdcall put_Draft( 
                VARIANT_BOOL RHS);

            HRESULT __stdcall get_FirstPageNumber( 
                long *RHS);

            HRESULT __stdcall put_FirstPageNumber( 
                long RHS);

            HRESULT __stdcall get_FitToPagesTall( 
                VARIANT *RHS);

            HRESULT __stdcall put_FitToPagesTall( 
                VARIANT RHS);

            HRESULT __stdcall get_FitToPagesWide( 
                VARIANT *RHS);

            HRESULT __stdcall put_FitToPagesWide( 
                VARIANT RHS);

            HRESULT __stdcall get_FooterMargin( 
                double *RHS);

            HRESULT __stdcall put_FooterMargin( 
                double RHS);

            HRESULT __stdcall get_HeaderMargin( 
                double *RHS);

            HRESULT __stdcall put_HeaderMargin( 
                double RHS);

            HRESULT __stdcall get_LeftFooter( 
                BSTR *RHS);

            HRESULT __stdcall put_LeftFooter( 
                BSTR RHS);

            HRESULT __stdcall get_LeftHeader( 
                BSTR *RHS);

            HRESULT __stdcall put_LeftHeader( 
                BSTR RHS);

            HRESULT __stdcall get_LeftMargin( 
                double *RHS);

            HRESULT __stdcall put_LeftMargin( 
                double RHS);

            HRESULT __stdcall get_Order( 
                XlOrder *RHS);

            HRESULT __stdcall put_Order( 
                XlOrder RHS);

            HRESULT __stdcall get_Orientation( 
                XlPageOrientation *RHS);

            HRESULT __stdcall put_Orientation( 
                XlPageOrientation RHS);

            HRESULT __stdcall get_PaperSize( 
                XlPaperSize *RHS);

            HRESULT __stdcall put_PaperSize( 
                XlPaperSize RHS);

            HRESULT __stdcall get_PrintArea( 
                BSTR *RHS);

            HRESULT __stdcall put_PrintArea( 
                BSTR RHS);

            HRESULT __stdcall get_PrintGridlines( 
                VARIANT_BOOL *RHS);

            HRESULT __stdcall put_PrintGridlines( 
                VARIANT_BOOL RHS);

            HRESULT __stdcall get_PrintHeadings( 
                VARIANT_BOOL *RHS);

            HRESULT __stdcall put_PrintHeadings( 
                VARIANT_BOOL RHS);

            HRESULT __stdcall get_PrintNotes( 
                VARIANT_BOOL *RHS);

            HRESULT __stdcall put_PrintNotes( 
                VARIANT_BOOL RHS);

            HRESULT __stdcall get_PrintQuality( 
                VARIANT Index,
                VARIANT *RHS);

            HRESULT __stdcall put_PrintQuality( 
                VARIANT Index,
                VARIANT RHS);

            HRESULT __stdcall get_PrintTitleColumns( 
                BSTR *RHS);

            HRESULT __stdcall put_PrintTitleColumns( 
                BSTR RHS);

            HRESULT __stdcall get_PrintTitleRows( 
                BSTR *RHS);

            HRESULT __stdcall put_PrintTitleRows( 
                BSTR RHS);

            HRESULT __stdcall get_RightFooter( 
                BSTR *RHS);

            HRESULT __stdcall put_RightFooter( 
                BSTR RHS);

            HRESULT __stdcall get_RightHeader( 
                BSTR *RHS);

            HRESULT __stdcall put_RightHeader( 
                BSTR RHS);

            HRESULT __stdcall get_RightMargin( 
                double *RHS);

            HRESULT __stdcall put_RightMargin( 
                double RHS);

            HRESULT __stdcall get_TopMargin( 
                double *RHS);

            HRESULT __stdcall put_TopMargin( 
                double RHS);

            HRESULT __stdcall get_Zoom( 
                VARIANT *RHS);

            HRESULT __stdcall put_Zoom( 
                VARIANT RHS);

            HRESULT __stdcall get_PrintComments( 
                XlPrintLocation *RHS);

            HRESULT __stdcall put_PrintComments( 
                XlPrintLocation RHS);

            HRESULT __stdcall get_PrintErrors( 
                XlPrintErrors *RHS);

            HRESULT __stdcall put_PrintErrors( 
                XlPrintErrors RHS);

            HRESULT __stdcall get_CenterHeaderPicture( 
                IDispatch **RHS);

            HRESULT __stdcall get_CenterFooterPicture( 
                IDispatch **RHS);

            HRESULT __stdcall get_LeftHeaderPicture( 
                IDispatch **RHS);

            HRESULT __stdcall get_LeftFooterPicture( 
                IDispatch **RHS);

            HRESULT __stdcall get_RightHeaderPicture( 
                IDispatch **RHS);

            HRESULT __stdcall get_RightFooterPicture( 
                IDispatch **RHS);

        public:

            HRESULT __stdcall Initialize(CRange* pSheet, OpenOfficeWrapper::COOPageSetupStylePtr pStyle);

        private:

            CRange* m_pSheet;
            OpenOfficeWrapper::COOPageSetupStylePtr m_pPageSetupStyle;

        };

        typedef CComObject<CPageSetup> CPageSetupObject;
        typedef CComPtr<CPageSetup> CPageSetupPtr;

    }
}

#endif // _PAGESETUP_H_