
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _WORKBOOOK_H_
#define _WORKBOOOK_H_

#include "Sheets.h"
#include "DispatchHook.h"
#include "OOCalcDocument.h"

/*
	CWorkbook class Represents a Microsoft Excel workbook by using OpenOffice.
	It implements IWorkbook COM interface.
*/

namespace AutomateIT
{
	namespace ExcelClone
	{
		class CApplication;

		class ATL_NO_VTABLE CWorkbook :
			public CComObjectRootEx<CComSingleThreadModel>,
			public CDispatchHook<IDispatchImpl<_Workbook, &IID__Workbook, &LIBID_ExcelCloneLib, 1, 0> >
		{
		public:
			CWorkbook();
			virtual ~CWorkbook();

			BEGIN_COM_MAP(CWorkbook)
				COM_INTERFACE_ENTRY(_Workbook)
				COM_INTERFACE_ENTRY(IDispatch)
			END_COM_MAP()

		public:

              HRESULT STDMETHODCALLTYPE get_Application( 
                 _Application **RHS);

              HRESULT STDMETHODCALLTYPE get_Creator( 
                 XlCreator *RHS);

              HRESULT STDMETHODCALLTYPE get_Parent( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE get_AcceptLabelsInFormulas( 
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_AcceptLabelsInFormulas( 
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE Activate( 
                 long lcid);

              HRESULT STDMETHODCALLTYPE get_ActiveChart( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE get_ActiveSheet( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE get_Author( 
                 long lcid,
                 BSTR *RHS);

              HRESULT STDMETHODCALLTYPE put_Author( 
                 long lcid,
                 BSTR RHS);

              HRESULT STDMETHODCALLTYPE get_AutoUpdateFrequency( 
                 long *RHS);

              HRESULT STDMETHODCALLTYPE put_AutoUpdateFrequency( 
                 long RHS);

              HRESULT STDMETHODCALLTYPE get_AutoUpdateSaveChanges( 
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_AutoUpdateSaveChanges( 
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE get_ChangeHistoryDuration( 
                 long *RHS);

              HRESULT STDMETHODCALLTYPE put_ChangeHistoryDuration( 
                 long RHS);

              HRESULT STDMETHODCALLTYPE get_BuiltinDocumentProperties( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE ChangeFileAccess( 
                 XlFileAccess Mode,
                 VARIANT WritePassword,
                 VARIANT Notify,
                 long lcid);

              HRESULT STDMETHODCALLTYPE ChangeLink( 
                 BSTR Name,
                 BSTR NewName,
                 XlLinkType Type,
                 long lcid);

              HRESULT STDMETHODCALLTYPE get_Charts( 
                 Sheets **RHS);

              HRESULT STDMETHODCALLTYPE Close( 
                 VARIANT SaveChanges,
                 VARIANT Filename,
                 VARIANT RouteWorkbook,
                 long lcid);

              HRESULT STDMETHODCALLTYPE get_CodeName( 
                 BSTR *RHS);

              HRESULT STDMETHODCALLTYPE get__CodeName( 
                 BSTR *RHS);

              HRESULT STDMETHODCALLTYPE put__CodeName( 
                 BSTR RHS);

              HRESULT STDMETHODCALLTYPE get_Colors( 
                 VARIANT Index,
                 long lcid,
                 VARIANT *RHS);

              HRESULT STDMETHODCALLTYPE put_Colors( 
                 VARIANT Index,
                 long lcid,
                 VARIANT RHS);

              HRESULT STDMETHODCALLTYPE get_CommandBars( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE get_Comments( 
                 long lcid,
                 BSTR *RHS);

              HRESULT STDMETHODCALLTYPE put_Comments( 
                 long lcid,
                 BSTR RHS);

              HRESULT STDMETHODCALLTYPE get_ConflictResolution( 
                 XlSaveConflictResolution *RHS);

              HRESULT STDMETHODCALLTYPE put_ConflictResolution( 
                 XlSaveConflictResolution RHS);

              HRESULT STDMETHODCALLTYPE get_Container( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE get_CreateBackup( 
                 long lcid,
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE get_CustomDocumentProperties( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE get_Date1904( 
                 long lcid,
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_Date1904( 
                 long lcid,
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE DeleteNumberFormat( 
                 BSTR NumberFormat,
                 long lcid);

              HRESULT STDMETHODCALLTYPE get_DialogSheets( 
                 Sheets **RHS);

              HRESULT STDMETHODCALLTYPE get_DisplayDrawingObjects( 
                 long lcid,
                 XlDisplayDrawingObjects *RHS);

              HRESULT STDMETHODCALLTYPE put_DisplayDrawingObjects( 
                 long lcid,
                 XlDisplayDrawingObjects RHS);

              HRESULT STDMETHODCALLTYPE ExclusiveAccess( 
                 long lcid,
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE get_FileFormat( 
                 long lcid,
                 XlFileFormat *RHS);

              HRESULT STDMETHODCALLTYPE ForwardMailer( 
                 long lcid);

              HRESULT STDMETHODCALLTYPE get_FullName( 
                 long lcid,
                 BSTR *RHS);

              HRESULT STDMETHODCALLTYPE get_HasMailer( 
                 long lcid,
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_HasMailer( 
                 long lcid,
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE get_HasPassword( 
                 long lcid,
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE get_HasRoutingSlip( 
                 long lcid,
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_HasRoutingSlip( 
                 long lcid,
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE get_IsAddin( 
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_IsAddin( 
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE get_Keywords( 
                 long lcid,
                 BSTR *RHS);

              HRESULT STDMETHODCALLTYPE put_Keywords( 
                 long lcid,
                 BSTR RHS);

              HRESULT STDMETHODCALLTYPE LinkInfo( 
                 BSTR Name,
                 XlLinkInfo LinkInfo,
                 VARIANT Type,
                 VARIANT EditionRef,
                 long lcid,
                 VARIANT *RHS);

              HRESULT STDMETHODCALLTYPE LinkSources( 
                 VARIANT Type,
                 long lcid,
                 VARIANT *RHS);

              HRESULT STDMETHODCALLTYPE get_Mailer( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE MergeWorkbook( 
                 VARIANT Filename);

              HRESULT STDMETHODCALLTYPE get_Modules( 
                 Sheets **RHS);

              HRESULT STDMETHODCALLTYPE get_MultiUserEditing( 
                 long lcid,
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE get_Name( 
                 BSTR *RHS);

              HRESULT STDMETHODCALLTYPE get_Names( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE NewWindow( 
                 long lcid,
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE get_OnSave( 
                 long lcid,
                 BSTR *RHS);

              HRESULT STDMETHODCALLTYPE put_OnSave( 
                 long lcid,
                 BSTR RHS);

              HRESULT STDMETHODCALLTYPE get_OnSheetActivate( 
                 long lcid,
                 BSTR *RHS);

              HRESULT STDMETHODCALLTYPE put_OnSheetActivate( 
                 long lcid,
                 BSTR RHS);

              HRESULT STDMETHODCALLTYPE get_OnSheetDeactivate( 
                 long lcid,
                 BSTR *RHS);

              HRESULT STDMETHODCALLTYPE put_OnSheetDeactivate( 
                 long lcid,
                 BSTR RHS);

              HRESULT STDMETHODCALLTYPE OpenLinks( 
                 BSTR Name,
                 VARIANT ReadOnly,
                 VARIANT Type,
                 long lcid);

              HRESULT STDMETHODCALLTYPE get_Path( 
                 long lcid,
                 BSTR *RHS);

              HRESULT STDMETHODCALLTYPE get_PersonalViewListSettings( 
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_PersonalViewListSettings( 
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE get_PersonalViewPrintSettings( 
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_PersonalViewPrintSettings( 
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE PivotCaches( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE Post( 
                 VARIANT DestName,
                 long lcid);

              HRESULT STDMETHODCALLTYPE get_PrecisionAsDisplayed( 
                 long lcid,
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_PrecisionAsDisplayed( 
                 long lcid,
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE _PrintOut( 
                 VARIANT From,
                 VARIANT To,
                 VARIANT Copies,
                 VARIANT Preview,
                 VARIANT ActivePrinter,
                 VARIANT PrintToFile,
                 VARIANT Collate,
                 long lcid);

              HRESULT STDMETHODCALLTYPE PrintPreview( 
                 VARIANT EnableChanges,
                 long lcid);

              HRESULT STDMETHODCALLTYPE _Protect( 
                 VARIANT Password,
                 VARIANT Structure,
                 VARIANT Windows);

              HRESULT STDMETHODCALLTYPE ProtectSharing( 
                 VARIANT Filename,
                 VARIANT Password,
                 VARIANT WriteResPassword,
                 VARIANT ReadOnlyRecommended,
                 VARIANT CreateBackup,
                 VARIANT SharingPassword);

              HRESULT STDMETHODCALLTYPE get_ProtectStructure( 
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE get_ProtectWindows( 
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE get_ReadOnly( 
                 long lcid,
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE get__ReadOnlyRecommended( 
                 long lcid,
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE RefreshAll( void);

              HRESULT STDMETHODCALLTYPE Reply( 
                 long lcid);

              HRESULT STDMETHODCALLTYPE ReplyAll( 
                 long lcid);

              HRESULT STDMETHODCALLTYPE RemoveUser( 
                 long Index);

              HRESULT STDMETHODCALLTYPE get_RevisionNumber( 
                 long lcid,
                 long *RHS);

              HRESULT STDMETHODCALLTYPE Route( 
                 long lcid);

              HRESULT STDMETHODCALLTYPE get_Routed( 
                 long lcid,
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE get_RoutingSlip( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE RunAutoMacros( 
                 XlRunAutoMacro Which,
                 long lcid);

              HRESULT STDMETHODCALLTYPE Save( 
                 long lcid);

              HRESULT STDMETHODCALLTYPE _SaveAs( 
                 VARIANT Filename,
                 VARIANT FileFormat,
                 VARIANT Password,
                 VARIANT WriteResPassword,
                 VARIANT ReadOnlyRecommended,
                 VARIANT CreateBackup,
                 XlSaveAsAccessMode AccessMode,
                 VARIANT ConflictResolution,
                 VARIANT AddToMru,
                 VARIANT TextCodepage,
                 VARIANT TextVisualLayout,
                 long lcid);

              HRESULT STDMETHODCALLTYPE SaveCopyAs( 
                 VARIANT Filename,
                 long lcid);

              HRESULT STDMETHODCALLTYPE get_Saved( 
                 long lcid,
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_Saved( 
                 long lcid,
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE get_SaveLinkValues( 
                 long lcid,
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_SaveLinkValues( 
                 long lcid,
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE SendMail( 
                 VARIANT Recipients,
                 VARIANT Subject,
                 VARIANT ReturnReceipt,
                 long lcid);

              HRESULT STDMETHODCALLTYPE SendMailer( 
                 VARIANT FileFormat,
                 XlPriority Priority,
                 long lcid);

              HRESULT STDMETHODCALLTYPE SetLinkOnData( 
                 BSTR Name,
                 VARIANT Procedure,
                 long lcid);

              HRESULT STDMETHODCALLTYPE get_Sheets( 
                 Sheets **RHS);

              HRESULT STDMETHODCALLTYPE get_ShowConflictHistory( 
                 long lcid,
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_ShowConflictHistory( 
                 long lcid,
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE get_Styles( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE get_Subject( 
                 long lcid,
                 BSTR *RHS);

              HRESULT STDMETHODCALLTYPE put_Subject( 
                 long lcid,
                 BSTR RHS);

              HRESULT STDMETHODCALLTYPE get_Title( 
                 long lcid,
                 BSTR *RHS);

              HRESULT STDMETHODCALLTYPE put_Title( 
                 long lcid,
                 BSTR RHS);

              HRESULT STDMETHODCALLTYPE Unprotect( 
                 VARIANT Password,
                 long lcid);

              HRESULT STDMETHODCALLTYPE UnprotectSharing( 
                 VARIANT SharingPassword);

              HRESULT STDMETHODCALLTYPE UpdateFromFile( 
                 long lcid);

              HRESULT STDMETHODCALLTYPE UpdateLink( 
                 VARIANT Name,
                 VARIANT Type,
                 long lcid);

              HRESULT STDMETHODCALLTYPE get_UpdateRemoteReferences( 
                 long lcid,
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_UpdateRemoteReferences( 
                 long lcid,
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE get_UserControl( 
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_UserControl( 
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE get_UserStatus( 
                 long lcid,
                 VARIANT *RHS);

              HRESULT STDMETHODCALLTYPE get_CustomViews( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE get_Windows( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE get_Worksheets( 
                 Sheets **RHS);

              HRESULT STDMETHODCALLTYPE get_WriteReserved( 
                 long lcid,
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE get_WriteReservedBy( 
                 long lcid,
                 BSTR *RHS);

              HRESULT STDMETHODCALLTYPE get_Excel4IntlMacroSheets( 
                 Sheets **RHS);

              HRESULT STDMETHODCALLTYPE get_Excel4MacroSheets( 
                 Sheets **RHS);

              HRESULT STDMETHODCALLTYPE get_TemplateRemoveExtData( 
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_TemplateRemoveExtData( 
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE HighlightChangesOptions( 
                 VARIANT When,
                 VARIANT Who,
                 VARIANT Where);

              HRESULT STDMETHODCALLTYPE get_HighlightChangesOnScreen( 
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_HighlightChangesOnScreen( 
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE get_KeepChangeHistory( 
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_KeepChangeHistory( 
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE get_ListChangesOnNewSheet( 
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_ListChangesOnNewSheet( 
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE PurgeChangeHistoryNow( 
                 long Days,
                 VARIANT SharingPassword);

              HRESULT STDMETHODCALLTYPE AcceptAllChanges( 
                 VARIANT When,
                 VARIANT Who,
                 VARIANT Where);

              HRESULT STDMETHODCALLTYPE RejectAllChanges( 
                 VARIANT When,
                 VARIANT Who,
                 VARIANT Where);

              HRESULT STDMETHODCALLTYPE PivotTableWizard( 
                 VARIANT SourceType,
                 VARIANT SourceData,
                 VARIANT TableDestination,
                 VARIANT TableName,
                 VARIANT RowGrand,
                 VARIANT ColumnGrand,
                 VARIANT SaveData,
                 VARIANT HasAutoFormat,
                 VARIANT AutoPage,
                 VARIANT Reserved,
                 VARIANT BackgroundQuery,
                 VARIANT OptimizeCache,
                 VARIANT PageFieldOrder,
                 VARIANT PageFieldWrapCount,
                 VARIANT ReadData,
                 VARIANT Connection,
                 long lcid);

              HRESULT STDMETHODCALLTYPE ResetColors( void);

              HRESULT STDMETHODCALLTYPE get_VBProject( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE FollowHyperlink( 
                 BSTR Address,
                 VARIANT SubAddress,
                 VARIANT NewWindow,
                 VARIANT AddHistory,
                 VARIANT ExtraInfo,
                 VARIANT Method,
                 VARIANT HeaderInfo);

              HRESULT STDMETHODCALLTYPE AddToFavorites( void);

              HRESULT STDMETHODCALLTYPE get_IsInplace( 
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE PrintOut( 
                 VARIANT From,
                 VARIANT To,
                 VARIANT Copies,
                 VARIANT Preview,
                 VARIANT ActivePrinter,
                 VARIANT PrintToFile,
                 VARIANT Collate,
                 VARIANT PrToFileName,
                 long lcid);

              HRESULT STDMETHODCALLTYPE WebPagePreview( void);

              HRESULT STDMETHODCALLTYPE get_PublishObjects( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE get_WebOptions( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE ReloadAs( 
                 MsoEncoding Encoding);

              HRESULT STDMETHODCALLTYPE get_HTMLProject( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE get_EnvelopeVisible( 
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_EnvelopeVisible( 
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE get_CalculationVersion( 
                 long *RHS);

              HRESULT STDMETHODCALLTYPE Dummy17( 
                 long calcid);

              HRESULT STDMETHODCALLTYPE sblt( 
                 BSTR s);

              HRESULT STDMETHODCALLTYPE get_VBASigned( 
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE get_ShowPivotTableFieldList( 
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_ShowPivotTableFieldList( 
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE get_UpdateLinks( 
                 XlUpdateLinks *RHS);

              HRESULT STDMETHODCALLTYPE put_UpdateLinks( 
                 XlUpdateLinks RHS);

              HRESULT STDMETHODCALLTYPE BreakLink( 
                 BSTR Name,
                 XlLinkType Type);

              HRESULT STDMETHODCALLTYPE Dummy16( void);

              HRESULT STDMETHODCALLTYPE SaveAs( 
                 VARIANT Filename,
                 VARIANT FileFormat,
                 VARIANT Password,
                 VARIANT WriteResPassword,
                 VARIANT ReadOnlyRecommended,
                 VARIANT CreateBackup,
                 XlSaveAsAccessMode AccessMode,
                 VARIANT ConflictResolution,
                 VARIANT AddToMru,
                 VARIANT TextCodepage,
                 VARIANT TextVisualLayout,
                 VARIANT Local,
                 long lcid);

              HRESULT STDMETHODCALLTYPE get_EnableAutoRecover( 
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_EnableAutoRecover( 
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE get_RemovePersonalInformation( 
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_RemovePersonalInformation( 
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE get_FullNameURLEncoded( 
                 long lcid,
                 BSTR *RHS);

              HRESULT STDMETHODCALLTYPE CheckIn( 
                 VARIANT SaveChanges,
                 VARIANT Comments,
                 VARIANT MakePublic);

              HRESULT STDMETHODCALLTYPE CanCheckIn( 
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE SendForReview( 
                 VARIANT Recipients,
                 VARIANT Subject,
                 VARIANT ShowMessage,
                 VARIANT IncludeAttachment);

              HRESULT STDMETHODCALLTYPE ReplyWithChanges( 
                 VARIANT ShowMessage);

              HRESULT STDMETHODCALLTYPE EndReview( void);

              HRESULT STDMETHODCALLTYPE get_Password( 
                 BSTR *RHS);

              HRESULT STDMETHODCALLTYPE put_Password( 
                 BSTR RHS);

              HRESULT STDMETHODCALLTYPE get_WritePassword( 
                 BSTR *RHS);

              HRESULT STDMETHODCALLTYPE put_WritePassword( 
                 BSTR RHS);

              HRESULT STDMETHODCALLTYPE get_PasswordEncryptionProvider( 
                 BSTR *RHS);

              HRESULT STDMETHODCALLTYPE get_PasswordEncryptionAlgorithm( 
                 BSTR *RHS);

              HRESULT STDMETHODCALLTYPE get_PasswordEncryptionKeyLength( 
                 long *RHS);

              HRESULT STDMETHODCALLTYPE SetPasswordEncryptionOptions( 
                 VARIANT PasswordEncryptionProvider,
                 VARIANT PasswordEncryptionAlgorithm,
                 VARIANT PasswordEncryptionKeyLength,
                 VARIANT PasswordEncryptionFileProperties);

              HRESULT STDMETHODCALLTYPE get_PasswordEncryptionFileProperties( 
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE get_ReadOnlyRecommended( 
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_ReadOnlyRecommended( 
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE Protect( 
                 VARIANT Password,
                 VARIANT Structure,
                 VARIANT Windows);

              HRESULT STDMETHODCALLTYPE get_SmartTagOptions( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE RecheckSmartTags( void);

              HRESULT STDMETHODCALLTYPE get_Permission( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE get_SharedWorkspace( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE get_Sync( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE SendFaxOverInternet( 
                 VARIANT Recipients,
                 VARIANT Subject,
                 VARIANT ShowMessage);

              HRESULT STDMETHODCALLTYPE get_XmlNamespaces( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE get_XmlMaps( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE XmlImport( 
                 BSTR Url,
                 IDispatch **ImportMap,
                 VARIANT Overwrite,
                 VARIANT Destination,
                 XlXmlImportResult *RHS);

              HRESULT STDMETHODCALLTYPE get_SmartDocument( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE get_DocumentLibraryVersions( 
                 IDispatch **RHS);

              HRESULT STDMETHODCALLTYPE get_InactiveListBorderVisible( 
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_InactiveListBorderVisible( 
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE get_DisplayInkComments( 
                 VARIANT_BOOL *RHS);

              HRESULT STDMETHODCALLTYPE put_DisplayInkComments( 
                 VARIANT_BOOL RHS);

              HRESULT STDMETHODCALLTYPE XmlImportXml( 
                 BSTR Data,
                 IDispatch **ImportMap,
                 VARIANT Overwrite,
                 VARIANT Destination,
                 XlXmlImportResult *RHS);

              HRESULT STDMETHODCALLTYPE SaveAsXMLData( 
                 BSTR Filename,
                 IDispatch *Map);

              HRESULT STDMETHODCALLTYPE ToggleFormsDesign( void);

			
		public:			
			STDMETHOD(Initialize)(CApplication* pApp);
			STDMETHOD(Initialize)(CApplication* pApp, CComVariant vFileName);
            STDMETHOD(Initialize)(CApplication* pApp, OpenOfficeWrapper::IDispatchPtr pDocument);
			
            OpenOfficeWrapper::COOCalcDocumentPtr GetOODocument() const;


		protected:
			CSheetsPtr m_Sheets;
			CApplication* m_ParentApplication;

            OpenOfficeWrapper::COOCalcDocumentPtr m_pOOCalcDocument;

		};

		typedef CComObject<CWorkbook> CWorkbookObject;
        typedef CComPtr<CWorkbook> CWorkbookPtr;
	}
}

#endif //_WORKBOOOK_H_