
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _OO_BORDER_LINE_H_
#define _OO_BORDER_LINE_H_

#pragma once

#include "IDispatchWrapper.h"

namespace AutomateIT
{
    namespace OpenOfficeWrapper
    {
        class ATL_NO_VTABLE COOBorderLine : 
            public CComObjectRootEx<CComSingleThreadModel>,
            public IUnknown
        {
        public:

            friend class COOTableBorder;

            BEGIN_COM_MAP(COOBorderLine)
                COM_INTERFACE_ENTRY(IUnknown)
            END_COM_MAP( )

            COOBorderLine();
            virtual ~COOBorderLine();

            HRESULT Initialize(IDispatchPtr dispatch);

            HRESULT get_InnerLineWidth(long* plInnerLineWidth);
            HRESULT put_InnerLineWidth(long lInnerLineWidth);

            HRESULT get_OuterLineWidth(long* plOuterLineWidth);
            HRESULT put_OuterLineWidth(long lOuterLineWidth);

            HRESULT get_LineDistance(long* plLineDistance);
            HRESULT put_LineDistance(long lLineDistance);

            HRESULT get_Color(int* piColor);
            HRESULT put_Color(int iColor);

        private:

            IDispatchPtr m_pdBorderLine;

        };

        typedef CComPtr<COOBorderLine> COOBorderLinePtr;
        typedef CComObject<COOBorderLine> COOBorderLineObject;

    }
}

#endif // _OO_BORDER_LINE_H_

