/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#include "StdAfx.h"
#include "OODispatchHelper.h"

using namespace AutomateIT::Utils;
using namespace AutomateIT::OpenOfficeWrapper;

COODispatchHelper::COODispatchHelper()
{
}

COODispatchHelper::~COODispatchHelper()
{
}

HRESULT COODispatchHelper::Initialize( IDispatchPtr dispatch )
{
    m_pdDispatchHelper = dispatch;
    return S_OK;
}


HRESULT COODispatchHelper::ExecuteDispatch( IDispatch* pComponent, BSTR bstrFunc )
{
    CComVariant result;

    CComVariant nullArray(NULL);
    nullArray.vt = VT_ARRAY | VT_VARIANT;

    HRESULT hr = AutoWrapper::Execute(
        DISPATCH_METHOD, 
        &result, 
        m_pdDispatchHelper, 
        OLESTR("executeDispatch"), 
        5, 
        CComVariant(pComponent), 
        CComVariant(bstrFunc),
        CComVariant(OLESTR("")),
        CComVariant(0),
        nullArray);

    CHECKERROR;
    return hr ; 
         
}