/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#include "StdAfx.h"
#include "OOEnumeration.h"

using namespace AutomateIT::Utils;
using namespace AutomateIT::OpenOfficeWrapper;

COOEnumeration::COOEnumeration()
{
}

COOEnumeration::~COOEnumeration()
{
}

HRESULT COOEnumeration::Initialize( IDispatchPtr dispatch )
{
    m_pdEnumeration = dispatch;
    return S_OK;
}

HRESULT COOEnumeration::HasMoreElements( bool* pValue )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_METHOD, &result, m_pdEnumeration, L"hasMoreElements", 0);
    CHECKERROR;

    (*pValue) = result.boolVal != VARIANT_FALSE;

    return hr;
}

HRESULT COOEnumeration::NextElement( IDispatch** ppValue )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_METHOD, &result, m_pdEnumeration, L"nextElement", 0);
    CHECKERROR;

    IDispatchPtr dispatch = result.pdispVal;

    (*ppValue) = dispatch;
    (*ppValue)->AddRef();

    return hr;
}