/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#include "StdAfx.h"
#include "OOTableBorder.h"

using namespace AutomateIT::Utils;
using namespace AutomateIT::OpenOfficeWrapper;

COOTableBorder::COOTableBorder()
{
}

COOTableBorder::~COOTableBorder()
{
}

HRESULT COOTableBorder::Initialize( IDispatchPtr dispatch )
{
    m_pdTableBorder = dispatch;
    return S_OK;
}

HRESULT COOTableBorder::get_TopLine( COOBorderLine** ppBorderLine )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdTableBorder, L"TopLine", 0);
    CHECKERROR;

    IDispatchPtr dispatch = result.pdispVal;

    COOBorderLineObject* pBorderLine(NULL); 
    hr = COOBorderLineObject::CreateInstance(&pBorderLine);
    CHECKERROR;

    COOBorderLinePtr pBorderLinePtr(pBorderLine); 
    hr = pBorderLinePtr->Initialize(dispatch);
    CHECKERROR;

    (*ppBorderLine) = pBorderLinePtr;
    (*ppBorderLine)->AddRef();

    return hr;
}

HRESULT COOTableBorder::get_LeftLine( COOBorderLine** ppBorderLine )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdTableBorder, L"LeftLine", 0);
    CHECKERROR;

    IDispatchPtr dispatch = result.pdispVal;

    COOBorderLineObject* pBorderLine(NULL); 
    hr = COOBorderLineObject::CreateInstance(&pBorderLine);
    CHECKERROR;

    COOBorderLinePtr pBorderLinePtr(pBorderLine); 
    hr = pBorderLinePtr->Initialize(dispatch);
    CHECKERROR;

    (*ppBorderLine) = pBorderLinePtr;
    (*ppBorderLine)->AddRef();

    return hr;
}

HRESULT COOTableBorder::get_RightLine( COOBorderLine** ppBorderLine )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdTableBorder, L"RightLine", 0);
    CHECKERROR;

    IDispatchPtr dispatch = result.pdispVal;

    COOBorderLineObject* pBorderLine(NULL); 
    hr = COOBorderLineObject::CreateInstance(&pBorderLine);
    CHECKERROR;

    COOBorderLinePtr pBorderLinePtr(pBorderLine); 
    hr = pBorderLinePtr->Initialize(dispatch);
    CHECKERROR;

    (*ppBorderLine) = pBorderLinePtr;
    (*ppBorderLine)->AddRef();

    return hr;
}

HRESULT COOTableBorder::get_BottomLine( COOBorderLine** ppBorderLine )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdTableBorder, L"BottomLine", 0);
    CHECKERROR;

    IDispatchPtr dispatch = result.pdispVal;

    COOBorderLineObject* pBorderLine(NULL); 
    hr = COOBorderLineObject::CreateInstance(&pBorderLine);
    CHECKERROR;

    COOBorderLinePtr pBorderLinePtr(pBorderLine); 
    hr = pBorderLinePtr->Initialize(dispatch);
    CHECKERROR;

    (*ppBorderLine) = pBorderLinePtr;
    (*ppBorderLine)->AddRef();

    return hr;
}

HRESULT COOTableBorder::get_HorizontalLine( COOBorderLine** ppBorderLine )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdTableBorder, L"HorizontalLine", 0);
    CHECKERROR;

    IDispatchPtr dispatch = result.pdispVal;

    COOBorderLineObject* pBorderLine(NULL); 
    hr = COOBorderLineObject::CreateInstance(&pBorderLine);
    CHECKERROR;

    COOBorderLinePtr pBorderLinePtr(pBorderLine); 
    hr = pBorderLinePtr->Initialize(dispatch);
    CHECKERROR;

    (*ppBorderLine) = pBorderLinePtr;
    (*ppBorderLine)->AddRef();

    return hr;
}

HRESULT COOTableBorder::get_VerticalLine( COOBorderLine** ppBorderLine )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdTableBorder, L"VerticalLine", 0);
    CHECKERROR;

    IDispatchPtr dispatch = result.pdispVal;

    COOBorderLineObject* pBorderLine(NULL); 
    hr = COOBorderLineObject::CreateInstance(&pBorderLine);
    CHECKERROR;

    COOBorderLinePtr pBorderLinePtr(pBorderLine); 
    hr = pBorderLinePtr->Initialize(dispatch);
    CHECKERROR;

    (*ppBorderLine) = pBorderLinePtr;
    (*ppBorderLine)->AddRef();

    return hr;
}

HRESULT COOTableBorder::put_TopLine( COOBorderLine* pBorderLine )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdTableBorder, L"TopLine", 1, CComVariant(pBorderLine->m_pdBorderLine.p));
    CHECKERROR;
    return hr;
}

HRESULT COOTableBorder::put_LeftLine( COOBorderLine* pBorderLine )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdTableBorder, L"LeftLine", 1, CComVariant(pBorderLine->m_pdBorderLine.p));
    CHECKERROR;
    return hr;
}

HRESULT COOTableBorder::put_RightLine( COOBorderLine* pBorderLine )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdTableBorder, L"RightLine", 1, CComVariant(pBorderLine->m_pdBorderLine.p));
    CHECKERROR;
    return hr;
}

HRESULT COOTableBorder::put_BottomLine( COOBorderLine* pBorderLine )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdTableBorder, L"BottomLine", 1, CComVariant(pBorderLine->m_pdBorderLine.p));
    CHECKERROR;
    return hr;
}

HRESULT COOTableBorder::put_HorizontalLine( COOBorderLine* pBorderLine )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdTableBorder, L"HorizontalLine", 1, CComVariant(pBorderLine->m_pdBorderLine.p));
    CHECKERROR;
    return hr;
}

HRESULT COOTableBorder::put_VerticalLine( COOBorderLine* pBorderLine )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdTableBorder, L"VerticalLine", 1, CComVariant(pBorderLine->m_pdBorderLine.p));
    CHECKERROR;
    return hr;
}