
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _WORD_SELECTION_H_
#define _WORD_SELECTION_H_

#include "resource.h"       
#include <atlctl.h>
#include "WordClone.h"
#include "WordStyle.h"
#include "WordDocument.h"
#include "WordParagraphs.h"

namespace AutomateIT
{
	namespace WordClone
	{
		class ATL_NO_VTABLE CWordSelection : 
			public CComObjectRootEx<CComSingleThreadModel>,
			public IDispatchImpl<Selection, &__uuidof(Selection), &LIBID_WordCloneLib, 8, 3>
		{
		public:

			CWordSelection();
			virtual ~CWordSelection();

			//DECLARE_REGISTRY_RESOURCEID(IDR_WORDSELECTION)

			BEGIN_COM_MAP(CWordSelection)
				COM_INTERFACE_ENTRY2(IDispatch, Selection)
				COM_INTERFACE_ENTRY(Selection)
			END_COM_MAP()

		public:

			DECLARE_PROTECT_FINAL_CONSTRUCT()

			HRESULT FinalConstruct()
			{
				return S_OK;
			}

			void FinalRelease() 
			{
			}

			// Selection Methods
		public:
			STDMETHOD(get_Text)(BSTR* prop);
			STDMETHOD(put_Text)(BSTR prop);
			STDMETHOD(get_FormattedText)(IDispatch** prop);
			STDMETHOD(put_FormattedText)(IDispatch* prop);
			STDMETHOD(get_Start)(long* prop);
			STDMETHOD(put_Start)(long prop);
			STDMETHOD(get_End)(long* prop);
			STDMETHOD(put_End)(long prop);
			STDMETHOD(get_Font)(_Font** prop);
			STDMETHOD(put_Font)(_Font* prop);
			STDMETHOD(get_Type)(WdSelectionType* prop);
			STDMETHOD(get_StoryType)(WdStoryType* prop);
			STDMETHOD(get_Style)(VARIANT* prop);
			STDMETHOD(put_Style)(VARIANT* prop);
			STDMETHOD(get_Tables)(IDispatch** prop);
			STDMETHOD(get_Words)(IDispatch** prop);
			STDMETHOD(get_Sentences)(IDispatch** prop);
			STDMETHOD(get_Characters)(IDispatch** prop);
			STDMETHOD(get_Footnotes)(IDispatch** prop);
			STDMETHOD(get_Endnotes)(IDispatch** prop);
			STDMETHOD(get_Comments)(IDispatch** prop);
			STDMETHOD(get_Cells)(IDispatch** prop);
			STDMETHOD(get_Sections)(Sections** prop);
			STDMETHOD(get_Paragraphs)(Paragraphs** prop);
			STDMETHOD(get_Borders)(IDispatch** prop);
			STDMETHOD(put_Borders)(IDispatch* prop);
			STDMETHOD(get_Shading)(IDispatch** prop);
			STDMETHOD(get_Fields)(IDispatch** prop);
			STDMETHOD(get_FormFields)(IDispatch** prop);
			STDMETHOD(get_Frames)(IDispatch** prop);
			STDMETHOD(get_ParagraphFormat)(IDispatch** prop);
			STDMETHOD(put_ParagraphFormat)(IDispatch* prop);
			STDMETHOD(get_PageSetup)(IDispatch** prop);
			STDMETHOD(put_PageSetup)(IDispatch* prop);
			STDMETHOD(get_Bookmarks)(IDispatch** prop);
			STDMETHOD(get_StoryLength)(long* prop);
			STDMETHOD(get_LanguageID)(WdLanguageID* prop);
			STDMETHOD(put_LanguageID)(WdLanguageID prop);
			STDMETHOD(get_LanguageIDFarEast)(WdLanguageID* prop);
			STDMETHOD(put_LanguageIDFarEast)(WdLanguageID prop);
			STDMETHOD(get_LanguageIDOther)(WdLanguageID* prop);
			STDMETHOD(put_LanguageIDOther)(WdLanguageID prop);
			STDMETHOD(get_Hyperlinks)(IDispatch** prop);
			STDMETHOD(get_Columns)(IDispatch** prop);
			STDMETHOD(get_Rows)(IDispatch** prop);
			STDMETHOD(get_HeaderFooter)(IDispatch** prop);
			STDMETHOD(get_IsEndOfRowMark)(VARIANT_BOOL* prop);
			STDMETHOD(get_BookmarkID)(long* prop);
			STDMETHOD(get_PreviousBookmarkID)(long* prop);
			STDMETHOD(get_Find)(IDispatch** prop);
			STDMETHOD(get_Range)(Range** prop);
			STDMETHOD(get_Information)(WdInformation Type, VARIANT* prop);
			STDMETHOD(get_Flags)(WdSelectionFlags* prop);
			STDMETHOD(put_Flags)(WdSelectionFlags prop);
			STDMETHOD(get_Active)(VARIANT_BOOL* prop);
			STDMETHOD(get_StartIsActive)(VARIANT_BOOL* prop);
			STDMETHOD(put_StartIsActive)(VARIANT_BOOL prop);
			STDMETHOD(get_IPAtEndOfLine)(VARIANT_BOOL* prop);
			STDMETHOD(get_ExtendMode)(VARIANT_BOOL* prop);
			STDMETHOD(put_ExtendMode)(VARIANT_BOOL prop);
			STDMETHOD(get_ColumnSelectMode)(VARIANT_BOOL* prop);
			STDMETHOD(put_ColumnSelectMode)(VARIANT_BOOL prop);
			STDMETHOD(get_Orientation)(WdTextOrientation* prop);
			STDMETHOD(put_Orientation)(WdTextOrientation prop);
			STDMETHOD(get_InlineShapes)(IDispatch** prop);
			STDMETHOD(get_Application)(IApplication** prop);
			STDMETHOD(get_Creator)(long* prop);
			STDMETHOD(get_Parent)(LPDISPATCH* prop);
			STDMETHOD(get_Document)(_Document** prop);
			STDMETHOD(get_ShapeRange)(IDispatch** prop);
			STDMETHOD(Select)();
			STDMETHOD(SetRange)(long Start, long End);
			STDMETHOD(Collapse)(VARIANT* Direction);
			STDMETHOD(InsertBefore)(BSTR Text);
			STDMETHOD(InsertAfter)(BSTR Text);
			STDMETHOD(Next)(VARIANT* Unit, VARIANT* Count, IDispatch** prop);
			STDMETHOD(Previous)(VARIANT* Unit, VARIANT* Count, IDispatch** prop);
			STDMETHOD(StartOf)(VARIANT* Unit, VARIANT* Extend, long* prop);
			STDMETHOD(EndOf)(VARIANT* Unit, VARIANT* Extend, long* prop);
			STDMETHOD(Move)(VARIANT* Unit, VARIANT* Count, long* prop);
			STDMETHOD(MoveStart)(VARIANT* Unit, VARIANT* Count, long* prop);
			STDMETHOD(MoveEnd)(VARIANT* Unit, VARIANT* Count, long* prop);
			STDMETHOD(MoveWhile)(VARIANT* Cset, VARIANT* Count, long* prop);
			STDMETHOD(MoveStartWhile)(VARIANT* Cset, VARIANT* Count, long* prop);
			STDMETHOD(MoveEndWhile)(VARIANT* Cset, VARIANT* Count, long* prop);
			STDMETHOD(MoveUntil)(VARIANT* Cset, VARIANT* Count, long* prop);
			STDMETHOD(MoveStartUntil)(VARIANT* Cset, VARIANT* Count, long* prop);
			STDMETHOD(MoveEndUntil)(VARIANT* Cset, VARIANT* Count, long* prop);
			STDMETHOD(Cut)();
			STDMETHOD(Copy)();
			STDMETHOD(Paste)();
			STDMETHOD(InsertBreak)(VARIANT* Type);
			STDMETHOD(InsertFile)(BSTR FileName, VARIANT* Range, VARIANT* ConfirmConversions, VARIANT* Link, VARIANT* Attachment);
			STDMETHOD(InStory)(IDispatch* Range, VARIANT_BOOL* prop);
			STDMETHOD(InRange)(IDispatch* Range, VARIANT_BOOL* prop);
			STDMETHOD(Delete)(VARIANT* Unit, VARIANT* Count, long* prop);
			STDMETHOD(Expand)(VARIANT* Unit, long* prop);
			STDMETHOD(InsertParagraph)();
			STDMETHOD(InsertParagraphAfter)();
			STDMETHOD(ConvertToTableOld)(VARIANT* Separator, VARIANT* NumRows, VARIANT* NumColumns, VARIANT* InitialColumnWidth, VARIANT* Format, VARIANT* ApplyBorders, VARIANT* ApplyShading, VARIANT* ApplyFont, VARIANT* ApplyColor, VARIANT* ApplyHeadingRows, VARIANT* ApplyLastRow, VARIANT* ApplyFirstColumn, VARIANT* ApplyLastColumn, VARIANT* AutoFit, IDispatch** prop);
			STDMETHOD(InsertDateTimeOld)(VARIANT* DateTimeFormat, VARIANT* InsertAsField, VARIANT* InsertAsFullWidth);
			STDMETHOD(InsertSymbol)(long CharacterNumber, VARIANT* Font, VARIANT* Unicode, VARIANT* Bias);
			STDMETHOD(InsertCrossReference_2002)(VARIANT* ReferenceType, WdReferenceKind ReferenceKind, VARIANT* ReferenceItem, VARIANT* InsertAsHyperlink, VARIANT* IncludePosition);
			STDMETHOD(InsertCaptionXP)(VARIANT* Label, VARIANT* Title, VARIANT* TitleAutoText, VARIANT* Position);
			STDMETHOD(CopyAsPicture)();
			STDMETHOD(SortOld)(VARIANT* ExcludeHeader, VARIANT* FieldNumber, VARIANT* SortFieldType, VARIANT* SortOrder, VARIANT* FieldNumber2, VARIANT* SortFieldType2, VARIANT* SortOrder2, VARIANT* FieldNumber3, VARIANT* SortFieldType3, VARIANT* SortOrder3, VARIANT* SortColumn, VARIANT* Separator, VARIANT* CaseSensitive, VARIANT* LanguageID);
			STDMETHOD(SortAscending)();
			STDMETHOD(SortDescending)();
			STDMETHOD(IsEqual)(IDispatch* Range, VARIANT_BOOL* prop);
			STDMETHOD(Calculate)(float* prop);
			STDMETHOD(GoTo)(VARIANT* What, VARIANT* Which, VARIANT* Count, VARIANT* Name, IDispatch** prop);
			STDMETHOD(GoToNext)(WdGoToItem What, IDispatch** prop);
			STDMETHOD(GoToPrevious)(WdGoToItem What, IDispatch** prop);
			STDMETHOD(PasteSpecial)(VARIANT* IconIndex, VARIANT* Link, VARIANT* Placement, VARIANT* DisplayAsIcon, VARIANT* DataType, VARIANT* IconFileName, VARIANT* IconLabel);
			STDMETHOD(PreviousField)(IDispatch** prop);
			STDMETHOD(NextField)(IDispatch** prop);
			STDMETHOD(InsertParagraphBefore)();
			STDMETHOD(InsertCells)(VARIANT* ShiftCells);
			STDMETHOD(Extend)(VARIANT* Character);
			STDMETHOD(Shrink)();
			STDMETHOD(MoveLeft)(VARIANT* Unit, VARIANT* Count, VARIANT* Extend, long* prop);
			STDMETHOD(MoveRight)(VARIANT* Unit, VARIANT* Count, VARIANT* Extend, long* prop);
			STDMETHOD(MoveUp)(VARIANT* Unit, VARIANT* Count, VARIANT* Extend, long* prop);
			STDMETHOD(MoveDown)(VARIANT* Unit, VARIANT* Count, VARIANT* Extend, long* prop);
			STDMETHOD(HomeKey)(VARIANT* Unit, VARIANT* Extend, long* prop);
			STDMETHOD(EndKey)(VARIANT* Unit, VARIANT* Extend, long* prop);
			STDMETHOD(EscapeKey)();
			STDMETHOD(TypeText)(BSTR Text);
			STDMETHOD(CopyFormat)();
			STDMETHOD(PasteFormat)();
			STDMETHOD(TypeParagraph)();
			STDMETHOD(TypeBackspace)();
			STDMETHOD(NextSubdocument)();
			STDMETHOD(PreviousSubdocument)();
			STDMETHOD(SelectColumn)();
			STDMETHOD(SelectCurrentFont)();
			STDMETHOD(SelectCurrentAlignment)();
			STDMETHOD(SelectCurrentSpacing)();
			STDMETHOD(SelectCurrentIndent)();
			STDMETHOD(SelectCurrentTabs)();
			STDMETHOD(SelectCurrentColor)();
			STDMETHOD(CreateTextbox)();
			STDMETHOD(WholeStory)();
			STDMETHOD(SelectRow)();
			STDMETHOD(SplitTable)();
			STDMETHOD(InsertRows)(VARIANT* NumRows);
			STDMETHOD(InsertColumns)();
			STDMETHOD(InsertFormula)(VARIANT* Formula, VARIANT* NumberFormat);
			STDMETHOD(NextRevision)(VARIANT* Wrap, IDispatch** prop);
			STDMETHOD(PreviousRevision)(VARIANT* Wrap, IDispatch** prop);
			STDMETHOD(PasteAsNestedTable)();
			STDMETHOD(CreateAutoTextEntry)(BSTR Name, BSTR StyleName, IDispatch** prop);
			STDMETHOD(DetectLanguage)();
			STDMETHOD(SelectCell)();
			STDMETHOD(InsertRowsBelow)(VARIANT* NumRows);
			STDMETHOD(InsertColumnsRight)();
			STDMETHOD(InsertRowsAbove)(VARIANT* NumRows);
			STDMETHOD(RtlRun)();
			STDMETHOD(LtrRun)();
			STDMETHOD(BoldRun)();
			STDMETHOD(ItalicRun)();
			STDMETHOD(RtlPara)();
			STDMETHOD(LtrPara)();
			STDMETHOD(InsertDateTime)(VARIANT* DateTimeFormat, VARIANT* InsertAsField, VARIANT* InsertAsFullWidth, VARIANT* DateLanguage, VARIANT* CalendarType);
			STDMETHOD(Sort2000)(VARIANT* ExcludeHeader, VARIANT* FieldNumber, VARIANT* SortFieldType, VARIANT* SortOrder, VARIANT* FieldNumber2, VARIANT* SortFieldType2, VARIANT* SortOrder2, VARIANT* FieldNumber3, VARIANT* SortFieldType3, VARIANT* SortOrder3, VARIANT* SortColumn, VARIANT* Separator, VARIANT* CaseSensitive, VARIANT* BidiSort, VARIANT* IgnoreThe, VARIANT* IgnoreKashida, VARIANT* IgnoreDiacritics, VARIANT* IgnoreHe, VARIANT* LanguageID);
			STDMETHOD(ConvertToTable)(VARIANT* Separator, VARIANT* NumRows, VARIANT* NumColumns, VARIANT* InitialColumnWidth, VARIANT* Format, VARIANT* ApplyBorders, VARIANT* ApplyShading, VARIANT* ApplyFont, VARIANT* ApplyColor, VARIANT* ApplyHeadingRows, VARIANT* ApplyLastRow, VARIANT* ApplyFirstColumn, VARIANT* ApplyLastColumn, VARIANT* AutoFit, VARIANT* AutoFitBehavior, VARIANT* DefaultTableBehavior, IDispatch** prop);
			STDMETHOD(get_NoProofing)(long* prop);
			STDMETHOD(put_NoProofing)(long prop);
			STDMETHOD(get_TopLevelTables)(IDispatch** prop);
			STDMETHOD(get_LanguageDetected)(VARIANT_BOOL* prop);
			STDMETHOD(put_LanguageDetected)(VARIANT_BOOL prop);
			STDMETHOD(get_FitTextWidth)(float* prop);
			STDMETHOD(put_FitTextWidth)(float prop);
			STDMETHOD(ClearFormatting)();
			STDMETHOD(PasteAppendTable)();
			STDMETHOD(get_HTMLDivisions)(IDispatch** prop);
			STDMETHOD(get_SmartTags)(IDispatch** prop);
			STDMETHOD(get_ChildShapeRange)(IDispatch** prop);
			STDMETHOD(get_HasChildShapeRange)(VARIANT_BOOL* prop);
			STDMETHOD(get_FootnoteOptions)(IDispatch** prop);
			STDMETHOD(get_EndnoteOptions)(IDispatch** prop);
			STDMETHOD(ToggleCharacterCode)();
			STDMETHOD(PasteAndFormat)(WdRecoveryType Type);
			STDMETHOD(PasteExcelTable)(VARIANT_BOOL LinkedToExcel, VARIANT_BOOL WordFormatting, VARIANT_BOOL RTF);
			STDMETHOD(ShrinkDiscontiguousSelection)();
			STDMETHOD(InsertStyleSeparator)();
			STDMETHOD(Sort)(VARIANT* ExcludeHeader, VARIANT* FieldNumber, VARIANT* SortFieldType, VARIANT* SortOrder, VARIANT* FieldNumber2, VARIANT* SortFieldType2, VARIANT* SortOrder2, VARIANT* FieldNumber3, VARIANT* SortFieldType3, VARIANT* SortOrder3, VARIANT* SortColumn, VARIANT* Separator, VARIANT* CaseSensitive, VARIANT* BidiSort, VARIANT* IgnoreThe, VARIANT* IgnoreKashida, VARIANT* IgnoreDiacritics, VARIANT* IgnoreHe, VARIANT* LanguageID, VARIANT* SubFieldNumber, VARIANT* SubFieldNumber2, VARIANT* SubFieldNumber3);
			STDMETHOD(get_XMLNodes)(IDispatch** prop);
			STDMETHOD(get_XMLParentNode)(IDispatch** prop);
			STDMETHOD(get_Editors)(IDispatch** prop);
			STDMETHOD(get_XML)(VARIANT_BOOL DataOnly, BSTR* prop);
			STDMETHOD(get_EnhMetaFileBits)(VARIANT* prop);
			STDMETHOD(GoToEditableRange)(VARIANT* EditorID, IDispatch** prop);
			STDMETHOD(InsertXML)(BSTR XML, VARIANT* Transform);
			STDMETHOD(InsertCaption)(VARIANT* Label, VARIANT* Title, VARIANT* TitleAutoText, VARIANT* Position, VARIANT* ExcludeLabel);
			STDMETHOD(InsertCrossReference)(VARIANT* ReferenceType, WdReferenceKind ReferenceKind, VARIANT* ReferenceItem, VARIANT* InsertAsHyperlink, VARIANT* IncludePosition, VARIANT* SeparateNumbers, VARIANT* SeparatorString);
		};
	}		
}

#endif //_WORD_SELECTION_H_