
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _WORD_STYLE_H_
#define _WORD_STYLE_H_

#include <atlcom.h>
#include "resource.h"       
#include "WordClone.h"
#include "WordParagraphFormat.h"

namespace AutomateIT
{
	namespace WordClone
	{
		class CWordDocument;

		class ATL_NO_VTABLE CWordStyle :
			public CComObjectRootEx<CComSingleThreadModel>,
			public IDispatchImpl<Style, &__uuidof(Style), &LIBID_WordCloneLib, 8, 3>
		{
		public:
			CWordStyle();
			virtual ~CWordStyle();

			//DECLARE_REGISTRY_RESOURCEID(IDR_WORDSTYLE)

			BEGIN_COM_MAP(CWordStyle)
				COM_INTERFACE_ENTRY(IDispatch)
				COM_INTERFACE_ENTRY(Style)
			END_COM_MAP()

			DECLARE_PROTECT_FINAL_CONSTRUCT()

			HRESULT FinalConstruct()
			{
				return S_OK;
			}

			void FinalRelease() 
			{
			}

			// Style Methods
		public:
			STDMETHOD(get_Application)(IApplication** prop);
			STDMETHOD(get_Creator)(long* prop);
			STDMETHOD(get_Parent)(LPDISPATCH* prop);
			STDMETHOD(get_NameLocal)(BSTR* prop);
			STDMETHOD(put_NameLocal)(BSTR prop);
			STDMETHOD(get_BaseStyle)(VARIANT* prop);
			STDMETHOD(put_BaseStyle)(VARIANT* prop);
			STDMETHOD(get_Description)(BSTR* prop);
			STDMETHOD(get_Type)(WdStyleType* prop);
			STDMETHOD(get_BuiltIn)(VARIANT_BOOL* prop);
			STDMETHOD(get_NextParagraphStyle)(VARIANT* prop);
			STDMETHOD(put_NextParagraphStyle)(VARIANT* prop);
			STDMETHOD(get_InUse)(VARIANT_BOOL* prop);
			STDMETHOD(get_Shading)(IDispatch** prop);
			STDMETHOD(get_Borders)(IDispatch** prop);
			STDMETHOD(put_Borders)(IDispatch* prop);
			STDMETHOD(get_ParagraphFormat)(_ParagraphFormat** prop);
			STDMETHOD(put_ParagraphFormat)(IDispatch* prop);
			STDMETHOD(get_Font)(_Font** prop);
			STDMETHOD(put_Font)(_Font* prop);
			STDMETHOD(get_Frame)(IDispatch** prop);
			STDMETHOD(get_LanguageID)(WdLanguageID* prop);
			STDMETHOD(put_LanguageID)(WdLanguageID prop);
			STDMETHOD(get_AutomaticallyUpdate)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutomaticallyUpdate)(VARIANT_BOOL prop);
			STDMETHOD(get_ListTemplate)(ListTemplate** prop);
			STDMETHOD(get_ListLevelNumber)(long* prop);
			STDMETHOD(get_LanguageIDFarEast)(WdLanguageID* prop);
			STDMETHOD(put_LanguageIDFarEast)(WdLanguageID prop);
			STDMETHOD(get_Hidden)(VARIANT_BOOL* prop);
			STDMETHOD(put_Hidden)(VARIANT_BOOL prop);
			STDMETHOD(Delete)();
			STDMETHOD(LinkToListTemplate)(ListTemplate* ListTemplate, VARIANT* ListLevelNumber);
			STDMETHOD(get_NoProofing)(long* prop);
			STDMETHOD(put_NoProofing)(long prop);
			STDMETHOD(get_LinkStyle)(VARIANT* prop);
			STDMETHOD(put_LinkStyle)(VARIANT* prop);
			STDMETHOD(get_Visibility)(VARIANT_BOOL* prop);
			STDMETHOD(put_Visibility)(VARIANT_BOOL prop);
			STDMETHOD(get_NoSpaceBetweenParagraphsOfSameStyle)(VARIANT_BOOL* prop);
			STDMETHOD(put_NoSpaceBetweenParagraphsOfSameStyle)(VARIANT_BOOL prop);
			STDMETHOD(get_Table)(IDispatch** prop);
			STDMETHOD(get_Locked)(VARIANT_BOOL* prop);
			STDMETHOD(put_Locked)(VARIANT_BOOL prop);
		};

		typedef CComPtr<CWordStyle> WordStylePtr;
		typedef CComObject<CWordStyle> WordStyleObj;
	}
}

#endif //_WORD_STYLE_H_