
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _WORD_TAB_STOPS_H_
#define _WORD_TAB_STOPS_H_

#include <atlcom.h>
#include "resource.h"       
#include "WordClone.h"

namespace AutomateIT
{
	namespace WordClone
	{
		class ATL_NO_VTABLE CWordTabStops : 
			public CComObjectRootEx<CComSingleThreadModel>,
			public IDispatchImpl<TabStops, &__uuidof(TabStops), &LIBID_WordCloneLib, 8, 3>
		{
		public:
			CWordTabStops();
			virtual ~CWordTabStops();

			BEGIN_COM_MAP(CWordTabStops)
				COM_INTERFACE_ENTRY(TabStops)
			END_COM_MAP()

            DECLARE_PROTECT_FINAL_CONSTRUCT()
		
			HRESULT FinalConstruct()
			{
				return S_OK;
			}

			void FinalRelease() 
			{
			}

			// TabStops interface Methods
		public:
			STDMETHOD(get__NewEnum)(LPUNKNOWN* prop);
			STDMETHOD(get_Count)(long* prop);
			STDMETHOD(get_Application)(IApplication** prop);
			STDMETHOD(get_Creator)(long* prop);
			STDMETHOD(get_Parent)(LPDISPATCH* prop);
			STDMETHOD(get_Item)(VARIANT* Index, TabStop** prop);
			STDMETHOD(Add)(float Position, VARIANT* Alignment, VARIANT* Leader, TabStop** prop);
			STDMETHOD(ClearAll)();
			STDMETHOD(Before)(float Position, TabStop** prop);
			STDMETHOD(After)(float Position, TabStop** prop);
		};
	}
}

#endif //_WORD_TAB_STOPS_H_