
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/


#pragma once

#include "OODocument.h"

#include <AutoWrapper.h>


/*
	COOWriterDocument class implements document functionality ( modifications, creation, fields operation etc.)
	NOTE: Currently it implements only small subset of document functionality.
*/

class COOWriterDocument 
{
	
	DWORD		m_dwCurrBookmark;
public :
    COODocument *m_pDoc;
// Field Constants 
	static const BYTE FieldTypeText;


// COOWriterDocument methods
	COOWriterDocument();
	~COOWriterDocument();
	

	COODocument* Attach	(COODocument *pDoc);
	COODocument* Detach ();

	HRESULT GetCurrentController(IDispatch **ppdController);
	static HRESULT GetCursor	(IDispatch *pdTextSource, IDispatch **ppdCursor);
	HRESULT GetText				(IDispatch **ppdText);
	HRESULT GetCursor			(IDispatch **ppdCursor);
	HRESULT GetViewCursor		(IDispatch **ppdCursor);

    HRESULT FileOpen(CComVariant Name);

    HRESULT FileNewDefault(BOOL bShowed);
    HRESULT FormFieldOptions( 
        VARIANT Name,
        VARIANT Enable,
        VARIANT TextType,
        VARIANT TextWidth,
        VARIANT TextDefault,
        VARIANT TextFormat,
        VARIANT CheckSize,
        VARIANT CheckWidth,
        VARIANT CheckDefault,
        VARIANT Type,
        VARIANT OwnHelp,
        VARIANT HelpText,
        VARIANT OwnStat,
        VARIANT StatText
        );
	
	DWORD	GetCurrentBookmarkIndex		 () const;
	HRESULT SelectBookmarkByIndex		 (DWORD dwBookmarkIndex);
	HRESULT SetCurrentBookmarkProperties (CComVariant vBookmarkName, CComVariant vText);
	HRESULT GetCurrentBookmarkProperties (CComVariant *vBookmarkName, CComVariant *vText);
	

	HRESULT SetBookmarkText(CComVariant vBookmarkName, CComVariant vText);
	HRESULT GetBookmarkText(CComVariant vBookmarkName, CComVariant *vText);
	HRESULT GetBookmarksCount(DWORD &dwCount);


    HRESULT InsertTextField(CComVariant vName, CComVariant vValue);
	HRESULT InsertInputField(CComVariant vName, CComVariant vHint, CComVariant vValue);

    HRESULT CreateTextfieldsEnumeration(IDispatch **pdEnumerator);
    HRESULT BindToDatasource(CComVariant vDSName, CComVariant vTableName);

    static  HRESULT HasMoreElements(IDispatch *pdEnumerator, BOOL &bRes);
    static  HRESULT NextElement(IDispatch *pdEnumerator, IDispatch **ppdNextElement);

    HRESULT AppActivate(BSTR WindowName, VARIANT Immediate);
    HRESULT NextField(short *pResult);
    HRESULT AppShow(VARIANT WindowName);
    HRESULT GetSelStartPos(long *pSelStartPos);
    HRESULT SetSelRange(long Pos1, long Pos2);

    HRESULT InsertDocumentFromPath(const std::wstring &sPath);

};
