
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#include "PropertyValue.h"

using namespace AutomateIT::Utils;

/*
	CPropertyValue class implements methods that allows 
	Retrieving/setting OpenOffice object properties.
*/
CPropertyValue::CPropertyValue(IDispatch *pdParent) :
	m_pdVal(NULL)
{
	// there are many of the Open Office functions use "com.sun.star.beans.PropertyValue",
	// using this method
	CComVariant res;
	CComVariant cvStr(L"com.sun.star.beans.PropertyValue");
	HRESULT hres = AutoWrapper::Execute (DISPATCH_METHOD, &res, pdParent, L"Bridge_GetStruct", 1, cvStr);
	if (hres == S_OK) 
	{
		m_pdVal = res.pdispVal;
		m_pdVal->AddRef();
	}
	else 
		m_pdVal = NULL;
}

CPropertyValue::~CPropertyValue()
{
	if (m_pdVal != NULL)
		m_pdVal->Release();
}

HRESULT CPropertyValue::SetPropertyValue(CComVariant vName, CComVariant vValue)
{
	if (m_pdVal == NULL)
		return E_INVALIDARG;
	CComVariant res;
	HRESULT hres = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &res, m_pdVal, L"Name", 1, vName);
	if (FAILED (hres)) 
		return hres;
	hres = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &res, m_pdVal, L"Value", 1, vValue);
		return hres;
}

BOOL CPropertyValue::IsValid()
{
	if (m_pdVal == NULL)
		return FALSE;
	else 
		return TRUE;
}

IDispatch* CPropertyValue::GetValueDispatch()
{
	return m_pdVal;
}