/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef LOG_H
#define LOG_H

#include <stdlib.h>
#include <string>

#ifdef _DEBUG
#define WRITE_LOG_A(param) AutomateIT::Utils::CLog::PrintA param
#define WRITE_LOG_W(param) AutomateIT::Utils::CLog::PrintW param
#else
#define WRITE_LOG_A(param)
#define WRITE_LOG_W(param)
#endif

#define WRITE_LOG_R_W(param) (AutomateIT::Utils::CLog::PrintW param)

namespace AutomateIT
{
	namespace Utils
	{
		class CLog
		{
		public:
			static void SetFileName();
			static int CLog::PrintA(const char* fmt, ...);
			static int CLog::PrintW(const wchar_t* fmt, ...);
		private:
			static std::string s_logFileName;
		};

	}
}

#endif // LOG_H
