
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#include "stdafx.h"
#include "tracing.h"

using namespace __tracing__;

__method__::__method__(const std::string& name, HRESULT& result) : 
	name_(name.begin(), name.end()), result_(result)
{
	WRITE_LOG_R_W((L"%s [BEGIN]", name_.c_str()));
}

__method__::~__method__()
{
	if (std::uncaught_exception())
	{
		WRITE_LOG_R_W((L"[ERROR]: DETECT EXCEPTION IN [%s]", name_.c_str()));
	}
    if (FAILED(result_))
    {
        WRITE_LOG_R_W((L"[ERROR]: DETECT ERROR IN [%s] HRESULT = 0x%X", name_.c_str(), result_));
    }
	WRITE_LOG_R_W((L"%s [END]", name_.c_str()));
}
